var WB = window.WB || {};

WB.SSTSettings={
    init:function ($) {
        var that = WB.SSTSettings;
        that.switchAction($);
        that.seoItem($);
        that.inputLivePreview($);
        that.analytics($);
        that.range($,$('#J_sitemapSEOSettingBox .wbs-input-range'),function (val) {
            return val * 100 + '%';
        });
        that.tabs($,$('#J_normalSettingTabs'))
    },

    switchAction:function ($, obj) {
        var $obj = obj || $('.wb-switch[data-target]');

        $obj.on('change',function () {
            var me = $(this), $target = $(me.data('target'));

            if (me.prop("checked")) {
                me.attr('data-value','true');
                $target.addClass('active');
            }else{
                me.attr('data-value','false');
                $target.removeClass('active');
            }
        })
    },

    seoItem:function ($) {
        // $('#seo_active').on('change',function(){
        //     if($(this).attr("checked")){
        //         $('#J_SEOseting').show();
        //     }else{
        //         $('#J_SEOseting').hide();
        //     }
        // });

        $('.input-with-count').each(function () {
            var me = $(this);

            WB.SSTSettings.getInputTextLength($, me.find('[data-max]'), me.find('.count'));
        });

        $('.settings-cate-dropdown').on('change',function () {
            var _val = $(this).val();

            $('#J_seo_' + _val).addClass('active').siblings('.cate-item').removeClass('active');
        });

        $('.wb-tags-module').each(function () {
            WB.SSTSettings.tagsModule($,$(this));
        });

        //初始preview
        $('.preview-desc').each(function () {
            var _max = 200, me = $(this), _content = me.text();
            if(_content.length > _max){
                _content = _content.substring(0,_max) + '...';
            }

            me.text(_content);
        });
        $('.preview-title').each(function () {
            var _max = 120, me = $(this), _content = me.text();
            if(_content.length > _max){
                _content = _content.substring(0,_max) + '...';
            }

            me.text(_content);
        });

        $('#J_switchDisplayMoreItems').on('click',function () {
            var active = $(this).attr('data-active');

            if(active == '0'){
                $(this).text('[ - 收起 ]');
                $(this).attr('data-active','1');
            }else{
                $(this).text('[ + 展开 ]');
                $(this).attr('data-active','0');
            }

            $('#J_moreSEOItems').toggleClass('active');
        })
    },

    tagsModule:function ($, obj) {
        var $obj = obj || $('.wb-tags-module'),
            $dataObj = $obj.find('[data-tags-value]'),
            $tagInput = $obj.find('.wb-tag-input'),
            $tagItems = $obj.find('.tag-items'),
            $count = $obj.find('.count'),
            orgData = $dataObj.val(),
            isPaste = false,
            // tagsArr = orgData.split(','),
            _inputSpace = 0; //输入的空格数

        updateCount();

        $tagInput.on('keydown blur paste',function (e) {
            var keyCode = e.keyCode || e.which || 0,
                $input = $(this);

            // console.log(isPaste);
            //for 判断连续输入空格
            if(keyCode === 32){
                _inputSpace++;
            }else{
                _inputSpace = 0;
            }

            if(e.type == 'paste' && !isPaste) isPaste =  true;
            // console.log('isPaste: ' + isPaste);
            //粘贴情况
            // if(e.type === "blur"){
            //
            //
            //     var _pasteContent = $.trim($tagInput.val()).split(',');
            //
            //     if(_pasteContent.length > 1){
            //         _pasteContent.forEach(function (value) {
            //             addTag(value);
            //         })
            //     }
            //
            //     console.log(_pasteContent);
            //     // console.log(e);
            // }

            if (e.type === 'blur' || keyCode === 13 || keyCode === 188 || _inputSpace > 1) {
                // var _thisVal = $.trim($tagInput.val());
                var _thisVal = $.trim($tagInput.val());
                // console.log(_thisVal);

                if(_thisVal == '') return false;

                if(isPaste){
                    var _thisValToArr = _thisVal.split(',');
                    console.log(_thisValToArr);

                    if(_thisValToArr.length > 0){
                        _thisValToArr.forEach(function (value) {
                            var _val = $.trim(value);
                            if(_val != ''){
                                addTag(_val);
                                updateVal(_val);
                            }else{
                                return false;
                            }
                        })
                    }
                    isPaste = false;
                }else{
                    addTag(_thisVal);
                    updateVal(_thisVal);
                }

                //清除当前输入内容
                $input.val('');

                updateCount();

                return false
            }
            else if (keyCode === 8 && $input.val().length === 0) { //退格清空
                $input.val('');

                return false
            }
        });

        //绑定删除按钮
        $obj.on('click', '.tag-item .del', function () {
            var delItem = $(this).parent(),
                delItemVal = $(this).attr('data-del-val');

            delTag(delItem, delItemVal);
        });

        function updateVal(val) {
            orgData = orgData != '' ? orgData + ',' + val : val;
            $dataObj.val(orgData);
        }

        function addTag(tag) {
            var tagHTML = '<div class="tag-item"><span>' + tag +' </span><a class="del" data-del-val="' + tag + '"></a></div>';

            //展示增加节点
            $tagItems.append(tagHTML);
        }

        function delTag(obj, val) {
            obj.remove();

            orgData = orgData.replace(val, "");
            orgData = orgData.replace(/(^,)|(,$)/, "");
            orgData = orgData.replace(/,,/, ",");

            $dataObj.val(orgData);

            updateCount();
        }

        function updateCount(count) {
            var _count = count || orgData.length, max = $dataObj.data('max') || 100;
            $count.html('已输入<b>' + _count + '</b>');

            $count[_count > max ? 'addClass' : 'removeClass']('hl');
        }
    },

    getInputTextLength:function($,$inputObj,$countObj){
        var _max = Number($inputObj.data('max'));
        $inputObj.each(function () {
            var _count = $(this).val().length;
            if(_count > _max) $countObj.addClass('hl');
            $countObj.html('已输入<b>' + _count + '</b>');
        });

        $inputObj.on('input change',function () {
            var _count = $(this).val().length;
            if(_count > _max) $countObj.addClass('hl');
            $countObj.html('已输入<b>' + _count + '</b>');
        })
    },

    inputLivePreview:function($){
        var $inputObj = $('[data-preview-target]');

        $inputObj.on('input change',function () {
            var _target = $(this).data('preview-target');
            var _max = Number($(this).data('max'));
            var _inputContent = $(this).val();

            if(_inputContent.length > _max){
                _inputContent = _inputContent.substring(0,_max) + '...';
            }

            $(_target).text(_inputContent);
        })
    },

    analytics: function ($) {
        var _source = $('[data-wba-source]').length && $('[data-wba-source]').data('wba-source') || window.wbaSource || document.domain;
        $('a[data-wba-campaign]').each(function () {
            var me = $(this),
                _campaign = me.data('wba-campaign'),
                _media = me.data('wba-media') || 'link',
                _url = me.attr('href');

            _url += _url.match("[\?]") ? '&' : '?';
            _url += 'utm_source=' + _source;
            _url += '&utm_media=' + _media;
            _url += '&utm_campaign=' + _campaign;

            me.attr('href',_url);
        })
    },

    //tab
    tabs:function($,obj,option){
        var option = option || {},
            $tabObj = obj || $('#J_tabBox'),
            $tabNavItem = option.tabNav || $tabObj.find('.tab-nav-item,.tab-nav li'),
            $tabCont = option.tabCont || $tabObj.find('.tab-cont'),
            currClassName = option.currClass || 'current',
            tabEvent = 'click',
            callBackFn = option.callBackFn,
            index = 0;

        $tabNavItem.on(tabEvent,function(){
            index = $(this).index();
            $tabNavItem.removeClass(currClassName).eq(index).addClass(currClassName);
            $tabCont.removeClass(currClassName).eq(index).addClass(currClassName);
            callBackFn && callBackFn();
        });
    },

    range: function ($,rangeObj,valFormat) {
        var $range = rangeObj || $('.wbs-input-range');

        $range.on('input change',function () {
            var _val = valFormat && valFormat($(this).val()) || $(this).val();
            $(this).next('.wbs-range-val').html(_val);
        })
    }
};

jQuery(document).ready(function($) {
    WB.SSTSettings.init($);

    $('#optionsframework-wrap').find('input,textarea').on('change',function () {
        $(window).on('beforeunload',function(){
            return confirm("您修改的设置尚未保存，确定离开此页面吗？");
        });
        $('#optionsframework-submit').addClass('sticky-bottom');
    });

    $('#optionsframework-submit .wbs-btn-primary').on('click',function () {
        $(window).unbind('beforeunload');
    });
});
